package owg.lgm.ar1.enemy;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.Invable;
import owg.lgm.ar1.Tuudna;
import owg.lgm.ar1.fallers.Fall55;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Enemy3 extends Invable implements Collider
{
	public Enemy3(double x, double y)
	{
		super(x, y, 0, false, true, false, "enemy3", null);
	}
	protected Enemy3(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	Skippn3 moog, moog2, moog3, moog4;
	double dirsp, sp, spsp;
	double resumeDir;

	@Override
	public void createEvent()
	{
		if (global.abzolniu>0) {
			destroy();
			return;
		}
		inv = 0;
		life = 5;
		dirsp = 2.5;
		sp = 64;
		spsp = 0;
		hspeed=2;
		resumeDir = 0;
		alarm[1] = (short)(90);
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		switch (alarmIndex)
		{
		case 0:
			if(moog != null)
			{
				moog.destroy();
				moog = null;
			}
			if(moog2 != null)
			{
				moog2.destroy();
				moog2 = null;
			}
			if(moog3 != null)
			{
				moog3.destroy();
				moog3 = null;
			}
			if(moog4 != null)
			{
				moog4.destroy();
				moog4 = null;
			}
			destroy();
			if (floor(random(4-1))!=0)
				instance_create(x+0,y+0,Fall55.class);
			break;
		case 1:
			Animal animal = instance(Animal.class);
			if (animal != null && distance_to_object(animal)<512)
			{
				{
					moog=instance_create(x,y,Skippn3.class);
					moog.m=this;
					moog.setDirection(315);
				}
				{
					moog2=instance_create(x,y,Skippn3.class);
					moog2.m=this;
					moog2.setDirection(225);
				}
				{
					moog3=instance_create(x,y,Skippn3.class);
					moog3.m=this;
					moog3.setDirection(135);
				}
				{
					moog4=instance_create(x,y,Skippn3.class);
					moog4.m=this;
					moog4.setDirection(45);
				}
			}
			if(hspeed != 0 || vspeed != 0)
            	resumeDir = getDirection();
			hspeed = 0;
			vspeed = 0;
			alarm[1] = (short)(120);
			alarm[2] = (short)(30);
			break;
		case 2:
			setDirSp(resumeDir, 3);
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
	@Override
	public void handleCollisions()
	{
		for(Tuudna other : getCollisions(Tuudna.class))
		{
			collisionTuudna(other);
			if(isDisposed())
				return;
		}
		super.handleCollisions();
	}
	protected void collisionTuudna(Tuudna other)
	{
		hspeed=-hspeed;
		resumeDir = getDirection();
	}
}
