package owg.lgm.ar1.enemy;

import owg.lgm.*;
import owg.lgm.ar1.Animal;
import owg.lgm.ar1.fallers.Fall55;

import static owg.lgm.ar1.accessories.AR1Globals.global;
import static owg.lgm.GMLib.*;

public class Hemmemy4 extends Enemy1 implements Collider
{
	public Hemmemy4(double x, double y)
	{
		super(x, y, 0, false, true, false, "enemy4", null);
	}
	protected Hemmemy4(double x, double y, int depth, boolean persistent, boolean visible, boolean solid, String sprite, String mask)
	{
		super(x, y, depth, persistent, visible, solid, sprite, mask);
	}

	double dir, yeh;

	@Override
	public void createEvent()
	{
		if (global.abzolniu>0) {
			destroy();
			return;
		}
		inv = 0;
		life = 9;
		hspeed=3;
		alarm[1] = (short)(120);
		dir = 0;
		yeh = 0;
	}
	@Override
	public void step()
	{
		yeh += -2+random(4);
		if (yeh>4)
			yeh = 4;
		if (yeh<-4)
			yeh = -4;
		Animal animal = instance(Animal.class);
		if (animal != null)
			dir = point_direction(x,y,animal.x,animal.y);
	}
	
	Sprite en4eye = Sprite.get("en4eye");
	Sprite en4gun = Sprite.get("en4gun");
	
	@Override
	public void render()
	{
		draw_sprite(sprite,image_index,x+0,y+0);
		draw_sprite(en4eye,image_index,x+-48,y+yeh);
		draw_sprite(en4gun,dir*16.0/360,x+48,y+yeh);
	}
	@Override
	public void alarmTriggered(int alarmIndex)
	{
		Animal animal = instance(Animal.class);
		switch (alarmIndex)
		{
		case 0:
			destroy();
			if (floor(random(2-1))==0)
				instance_create(x+0,y+0,Fall55.class);
			if (floor(random(2-1))==0)
				instance_create(x+48,y+0,Shotblb1.class);
			break;
		case 1:
			alarm[1] = (short)(200);
			alarm[2] = (short)(10);
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+48,y+0,Shotblb1.class);
			break;
		case 2:
			alarm[3] = (short)(10);
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+48,y+0,Shotblb1.class);
			break;
		case 3:
			if (animal != null)
				if (distance_to_object(animal)<512)
					instance_create(x+48,y+0,Shotblb1.class);
			break;
		default:
			super.alarmTriggered(alarmIndex);
			break;
		}
	}
}
