package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL;

public enum MagFilter
{
    NEAREST(GL.GL_NEAREST),
    LINEAR(GL.GL_LINEAR);
	
	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(MagFilter v : values())
			map.put(v.value, v);
	}
	public static MagFilter of(int glMagFilter) throws IllegalArgumentException
	{
		MagFilter r = (MagFilter) map.get(glMagFilter);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized magnification filter enum: "+glMagFilter+" ("+Integer.toHexString(glMagFilter)+")");
		return r;
	}

    public final int value;

    MagFilter(int value)
    {
        this.value = value;
    }
}
