package owg.lgm.gl;

import com.jogamp.common.util.IntObjectHashMap;
import com.jogamp.opengl.GL;

public enum MinFilter
{
    NEAREST(GL.GL_NEAREST),
    LINEAR(GL.GL_LINEAR),
    NEAREST_MIPMAP_NEAREST(GL.GL_NEAREST_MIPMAP_NEAREST),
    LINEAR_MIPMAP_NEAREST(GL.GL_LINEAR_MIPMAP_NEAREST),
    NEAREST_MIPMAP_LINEAR(GL.GL_NEAREST_MIPMAP_LINEAR),
    LINEAR_MIPMAP_LINEAR(GL.GL_LINEAR_MIPMAP_LINEAR);
	
	protected static final IntObjectHashMap map;
	static
	{
		map = new IntObjectHashMap();
		for(MinFilter v : values())
			map.put(v.value, v);
	}
	public static MinFilter of(int glMinFilter) throws IllegalArgumentException
	{
		MinFilter r = (MinFilter) map.get(glMinFilter);
		if(r == null)
			throw new IllegalArgumentException("Unrecognized minification filter enum: "+glMinFilter+" ("+Integer.toHexString(glMinFilter)+")");
		return r;
	}

    public final int value;

    MinFilter(int value)
    {
        this.value = value;
    }
}
