package owg.lgm.room;

import static owg.lgm.plaf.Engine.EN;

import com.jogamp.opengl.GL2ES1;

import owg.lgm.gl.Tex2D;
import owg.lgm.util.Letterbox;
import owg.util.math.Lerp;

public class CentralTransition implements TransitionFunc
{
	float[] views = new float[8];
	protected int surfaceWidth, surfaceHeight;
	
	@Override
	public void render(Tex2D prev, Tex2D next, float interp)
	{
		EN.gl.glMatrixMode(GL2ES1.GL_PROJECTION);
		EN.gl.glLoadIdentity();
		surfaceWidth = EN.getSurfaceWidth();
		surfaceHeight = EN.getSurfaceHeight();
		EN.gl.glOrtho(0, surfaceWidth, surfaceHeight, 0, -1, 1);
		Letterbox.getViewport(views, 0, surfaceWidth, surfaceHeight, prev.dataWidth, prev.dataHeight);
		Letterbox.getViewport(views, 4, surfaceWidth, surfaceHeight, next.dataWidth, next.dataHeight);
		EN.gl.glDisable(GL2ES1.GL_BLEND);
		renderPart(prev, views, 0, 
				views[2]>views[6] ? Lerp.lerp(views[2], views[6], interp)/views[2] : 1, 
				views[3]>views[7] ? Lerp.lerp(views[3], views[7], interp)/views[3] : 1);
		renderPart(next, views, 4, interp, interp);
		EN.gl.glEnable(GL2ES1.GL_BLEND);
	}

	protected void renderPart(Tex2D tex, float[] baseViewport, int baseViewportOff, float sx, float sy)
	{
		float w = baseViewport[baseViewportOff+2];
		float h = baseViewport[baseViewportOff+3];
		float x0 = baseViewport[baseViewportOff  ];
		float y0 = baseViewport[baseViewportOff+1];
		
		tex.begin();
		EN.gl.glMatrixMode(GL2ES1.GL_MODELVIEW);
		EN.gl.glLoadIdentity();
		EN.gl.glTranslatef(x0, y0, 0);
		EN.gl.glScalef(w, h, 0);
		
		EN.gl.glMatrixMode(GL2ES1.GL_TEXTURE);
		EN.gl.glTranslatef((1.0f-sx)*tex.mx/2, (1.0f-sy)*tex.my/2, 0);
		EN.gl.glScalef(tex.mx*sx, tex.my*sy, 1);
		EN.gl.glColor4f(1, 1, 1, 1);
		EN.nwRect.render(EN.gl);
		EN.gl.glLoadIdentity();
		EN.gl.glMatrixMode(GL2ES1.GL_MODELVIEW);
		tex.end();
	}
}
