package owg.lgm.room;

import com.jogamp.opengl.GL2ES1;

import owg.lgm.gl.Tex2D;
import owg.util.compass.Compass;

import static owg.lgm.plaf.Engine.EN;

public class InterlacingTransition extends DirectionalTransition
{
	public InterlacingTransition(Compass direction) {
		super(direction, 0, false, 1, true);
	}

	@Override
	public void render(Tex2D prev, Tex2D next, float interp)
	{
		EN.gl.glMatrixMode(GL2ES1.GL_PROJECTION);
		EN.gl.glLoadIdentity();
		surfaceWidth = EN.getSurfaceWidth();
		surfaceHeight = EN.getSurfaceHeight();
		EN.gl.glOrtho(0, surfaceWidth, surfaceHeight, 0, -1, 1);
		EN.gl.glMatrixMode(GL2ES1.GL_MODELVIEW);

		EN.gl.glDisable(GL2ES1.GL_BLEND);
		renderPart(prev, mvOld, shiftOld, interp, false);
		
		EN.gl.glEnable(GL2ES1.GL_STENCIL_TEST);
		EN.gl.glClearStencil(0);
		EN.gl.glClear(GL2ES1.GL_STENCIL_BUFFER_BIT);
		EN.gl.glStencilMask(-1);
		EN.gl.glStencilFunc(GL2ES1.GL_NOTEQUAL, 1, -1);
		EN.gl.glStencilOp(GL2ES1.GL_KEEP, GL2ES1.GL_KEEP, GL2ES1.GL_REPLACE);
				EN.gl.glColorMask(false, false, false, false);
		EN.gl.glLoadIdentity();
		EN.gl.glColor4f(1,1,1,1);
		if(direction.sdy == 0) {
			EN.gl.glScalef(8, surfaceHeight, 1);
			for(int x = 0; x<surfaceWidth; x+= 16) {
				EN.gl.glTranslatef(2, 0, 0);
				EN.nwRect.render(EN.gl);
			}
		} else {
			EN.gl.glScalef(surfaceWidth, 8, 1);
			for(int y = 0; y<surfaceHeight; y+= 16) {
				EN.gl.glTranslatef(0, 2, 0);
				EN.nwRect.render(EN.gl);
			}
		}
		EN.gl.glColorMask(true, true, true, true);
		renderPart(next, mvNew, shiftNew, Math.min(1, interp*2), true);
		EN.gl.glDisable(GL2ES1.GL_STENCIL_TEST);
		if(interp > 0.5)
			renderPart(next, mvNew, shiftNew, interp*2-1, true);
		EN.gl.glEnable(GL2ES1.GL_BLEND);
	}
}