package owg.lgm.room;

import static owg.lgm.plaf.Engine.EN;

import com.jogamp.opengl.GL2ES1;

import owg.lgm.gl.Tex2D;
import owg.lgm.util.Letterbox;

public class RotateTransition implements TransitionFunc
{
	float[] views = new float[8];
	protected int surfaceWidth, surfaceHeight;
	public final int angle;
	
	public RotateTransition(int angle)
	{
		this.angle = angle;
	}
	
	@Override
	public void render(Tex2D prev, Tex2D next, float interp)
	{
		EN.gl.glMatrixMode(GL2ES1.GL_PROJECTION);
		EN.gl.glLoadIdentity();
		surfaceWidth = EN.getSurfaceWidth();
		surfaceHeight = EN.getSurfaceHeight();
		EN.gl.glOrtho(0, surfaceWidth, surfaceHeight, 0, -1, 1);
		Letterbox.getViewport(views, 0, surfaceWidth, surfaceHeight, prev.dataWidth, prev.dataHeight);
		Letterbox.getViewport(views, 4, surfaceWidth, surfaceHeight, next.dataWidth, next.dataHeight);

		EN.gl.glDisable(GL2ES1.GL_BLEND);
		renderPart(prev, views, 0, 1,  0);
		renderPart(next, views, 4, interp, angle*(1-interp));
		EN.gl.glEnable(GL2ES1.GL_BLEND);
	}

	protected void renderPart(Tex2D tex, float[] baseViewport, int baseViewportOff, float scale, float rotation)
	{
		float w = baseViewport[baseViewportOff+2];
		float h = baseViewport[baseViewportOff+3];
		float x0 = baseViewport[baseViewportOff  ];
		float y0 = baseViewport[baseViewportOff+1];
		
		tex.begin();
		EN.gl.glMatrixMode(GL2ES1.GL_MODELVIEW);
		EN.gl.glLoadIdentity();
		EN.gl.glTranslatef(x0+w/2, y0+h/2, 0);
		EN.gl.glRotatef(rotation, 0, 0, 1);
		EN.gl.glTranslatef(-w/2, -h/2, 0);
		EN.gl.glScalef(w, h, 0);
		
		EN.gl.glMatrixMode(GL2ES1.GL_TEXTURE);
		EN.gl.glScalef(tex.mx, tex.my, 1);
		EN.gl.glColor4f(1, 1, 1, 1);
		EN.nwRect.render(EN.gl);
		EN.gl.glLoadIdentity();
		EN.gl.glMatrixMode(GL2ES1.GL_MODELVIEW);
		tex.end();
	}
}
