package owg.lgm.room;

import owg.lgm.gl.Tex2D;
import owg.lgm.util.AutoDestructibleImpl;

public class Transition extends AutoDestructibleImpl
{
	protected TransitionFunc func;
	protected int currentTime;
	protected int targetTime;
	protected Tex2D prev, next;

	public Transition(TransitionFunc func, int time, Tex2D prev)
	{
		this.func = func;
		this.targetTime = time;
		this.prev = prev;
		autoDestroy(prev);
	}
	
	public void init(Tex2D next)
	{
		this.currentTime = 0;
		this.next = next;
		autoDestroy(next);
	}
	
	public boolean render()
	{
		currentTime++;
		func.render(prev, next, (float)currentTime/targetTime);
		return (currentTime >= targetTime);
	}
}
