package owg.lgm.util;

import java.nio.Buffer;
import java.nio.ByteBuffer;
import java.nio.CharBuffer;
import java.nio.DoubleBuffer;
import java.nio.FloatBuffer;
import java.nio.IntBuffer;
import java.nio.LongBuffer;
import java.nio.ShortBuffer;

public class BufferUtil
{
	public static int sizeOfBufferElem(Class<? extends Buffer> type)
	{
		if(ByteBuffer.class.isAssignableFrom(type))
			return 1;
		else if(ShortBuffer.class.isAssignableFrom(type))
			return 2;
		else if(IntBuffer.class.isAssignableFrom(type))
			return 4;
		else if(LongBuffer.class.isAssignableFrom(type))
			return 8;
		else if(FloatBuffer.class.isAssignableFrom(type))
			return 4;
		else if(DoubleBuffer.class.isAssignableFrom(type))
			return 8;
		else if(CharBuffer.class.isAssignableFrom(type))
			return 2;
		else
			throw new RuntimeException(type.getName());
	}
}
