package owg.competent.soundfile;

import java.io.FilterInputStream;
import java.io.InputStream;

import javax.sound.sampled.AudioInputStream;

import owg.competent.SampleFormat;

/**<p>
 * An inputstream that gets the format of an audio file and reads audio data.
 * </p><p>
 * This is used over {@link AudioInputStream} because that class requires the 
 * length of the audio stream to be known in advance. That is unserviceable
 * since it rules out all audio file formats that support streaming, such as
 * ogg vorbis.
 * </p>*/
public abstract class AudioDecoderStream extends FilterInputStream 
{
	protected AudioDecoderStream(InputStream in) {
		super(in);
	}

	public abstract double getSampleRate();
	public abstract int getChannelCount();	
	public abstract SampleFormat getSampleFormat();
	public abstract boolean isLittleEndian();
}
